function [pth, pflg] = Fpm_DP_path_Dij(s,t,pp,F,W,c)

%find a path from s->t, 
%by dynamic programming, using Dijkstra' alg like-wise strategy
%try to maximize (increased imporstance score/increased number of node^c)
%iA, indicate if the corrsponding nodethe node is already in the partially built graph
%W: orginal adjacent matrix

%d[v]: (increased imporstance score/increased number of node^c) for the best
%path from s->v
%pre[v]: the node before v (for the best path from s->v)
%num[v]: increased number of node (for the best path from s->v)
%iE[v]: indicate if if node v is already expanded

if nargin<6
    c = 1;
end


pp = setdiff(pp,[s,t]);
W(pp,:) = 0;
W(:,pp) = 0;



[m,n] = size(W);
idx = [1:m];

iA = zeros(1,m);

len = m;

d = -1 * ones(m,1);
pre = -1 * ones(m,1);
num = zeros(m,1);
iE = zeros(m,1);


num(s) = 1;
d(s) = F(s)/(num(s)^c);
pre(s) = -1;

flag = 1;
while flag == 1
   id = find(iE==0);%all unexpanded node
   pp = find(d(id)==max(d(id)));%with largest value
   pp = id(pp(1));%next node to be expanded
   iE(pp) = 1;%marked as already expanded
   id2 = find(W(pp,:)~=0);
   
   fu = d(pp) * (num(pp)^c);%importance score captured by best path s->t
   for i=1:length(id2)%for every neibor of pp
       if iE(id2(i))==0%if is not expanded
       if iA(id2(i))==1%already in the output graph
           del = 0;
       else
           del = 1;
       end
       tmp = (fu+F(id2(i)))/((num(pp)+del)^c);
       if tmp>=d(id2(i))
           d(id2(i)) = tmp;
           num(id2(i)) = (num(pp)+del);
           pre(id2(i)) = pp;
       end
       end
   end
   if iE(t)==1
       flag=0;
   end
end


%back-trace the path s->t
pth = t;
pp = t;
while pre(pp)~=-1
    pth = [pre(pp) pth];
    pp = pre(pp);
end

if length(pth)>1
    pflg=1;
else
    pflg=-1;
end